/*
 *    fdc_detect.c - generic FDC driver for WD279x (Z80)
 *
 *    Copyright (c) 2012 by Michal Hucik <http://www.ordoz.com>
 *
 *    Thies program is free software; you can redistribute it and/or modify
 *    it under the terms of the GNU General Public License as published by
 *    the Free Software Foundation; either version 2 of the License, or
 *    (at your option) any later version.
 *
 *    driver_FDC is distributed in the hope that it will be useful,
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *    GNU General Public License for more details.
 *
 *    You should have received a copy of the GNU General Public License
 *    along with driver_FDC; if not, write to the Free Software
 *    Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
*/

__sfr __at	0xd9	FDC_TRACK;


/* _delay - modifikovatelna cekaci smycka (volano z ASM)
 *
 * Vstup:
 *	reg. DE * 8 => priblizny cas v us
 *
 * Poskodi reg.: DE, AF
*/
void _delay ( void ) __naked {

    __asm

    1$:
    dec de
    ld a,d
    or e
    jr nz, 1$
    ret
    
    __endasm;
}




#if 0
/* delay - modifikovatelna cekaci smycka (volano z C)
 *
 * Vstup:
 *	value * 8 => priblizny cas v us
*/
void delay ( unsigned int value ) __naked {
    (void) value;
    
    __asm

    pop bc
    pop de
    push de
    push bc
    
    jp __delay
        
    __endasm;
}
#endif







/*
 * fdc_detect - test zda je pritomen FDC
 *
 * ret_val:
 *	-1: nepritomen
 *	 0: pritomen
*/
#define FDC_TRACK_TEST_VALUE	0xa4	/* kvuli unikarte volime jinou testovaci hodnotu, nez se pouziva v ROM */
char fdc_detect ( void ) __naked {

    __asm
    
    xor a
    ld l,a
    
    ld a,#FDC_TRACK_TEST_VALUE
    ld b,a
    ld c,#_FDC_TRACK
    
    out (c),a
    ld de,#0x000f
    call __delay
    in a,(c)
    cp b
    ret z
    dec l
    ret
    
    __endasm;
}

